var _Object$assign = require('babel-runtime/core-js/object/assign').default;

var _Object$keys = require('babel-runtime/core-js/object/keys').default;

Object.defineProperty(exports, '__esModule', {
    value: true
});
var assign = _Object$assign;
var keys = _Object$keys;

function createFilterer(data, options) {
    options || (options = {});
    var cache = {};

    return function (query) {
        var subquery;

        if (!cache[query]) {
            for (var i = query.length - 1; i > 0; i -= 1) {
                subquery = query.substr(0, i);

                if (cache[subquery]) {
                    cache[query] = find(cache[subquery], query, options);
                    break;
                }
            }
        }

        if (!cache[query]) {
            cache[query] = find(data, query, options);
        }

        return cache[query];
    };
}

exports.default = createFilterer;
;

function find(data, query, options) {
    return keys(data).reduce(function (acc, key) {
        var value = data[key];
        var matches;

        if (isPrimitive(value)) {
            if (contains(query, key, options) || contains(query, value, options)) {
                acc[key] = value;
            }
        } else {
            if (contains(query, key, options)) {
                acc[key] = value;
            } else {
                matches = find(value, query, options);

                if (!isEmpty(matches)) {
                    assign(acc, pair(key, matches));
                }
            }
        }

        return acc;
    }, {});
}

function contains(query, string, options) {
    if (options.ignoreCase) {
        query = String(query).toLowerCase();
        return string && String(string).toLowerCase().indexOf(query) !== -1;
    } else {
        return string && String(string).indexOf(query) !== -1;
    }
}

function isPrimitive(value) {
    var t = getType(value);
    return t !== 'Object' && t !== 'Array';
}

function pair(key, value) {
    var p = {};
    p[key] = value;
    return p;
}
module.exports = exports.default;