exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _state = require('../state');

var _state2 = _interopRequireDefault(_state);

var _libHelpers = require('../lib/helpers');

exports['default'] = {
  enter: function enter(node, parent, scope, file) {
    var name = node.name.name;
    var subName = node.subName && node.subName.name;
    var fullName = name + (subName ? '.' + subName : '');

    // start new view
    _state.resetViewState();
    _state2['default'].currentView = fullName;
    _state2['default'].inView = fullName;
    _state2['default'].meta.views[fullName] = {
      location: _libHelpers.normalizeLocation(node.loc),
      file: file.opts.filename,
      styles: {},
      els: {}
    };

    node.block.motionView = true;

    return _libHelpers.t.callExpression(_libHelpers.t.identifier('Motion.view'), [_libHelpers.t.literal(fullName), _libHelpers.t.functionExpression(null, [_libHelpers.t.identifier('view'), _libHelpers.t.identifier('on'), _libHelpers.t.identifier('$')], node.block)]);
  }
};
module.exports = exports['default'];