exports.__esModule = true;

var _libHelpers = require('./lib/helpers');

var state = {
  basePath: false,
  currentView: null,
  meta: null, // meta-data for views for atom
  keyBase: null,
  inJSX: false,
  inView: null, // track current view name
  hasView: false, // if file has a view
  viewHasChildWithClass: false, // if view calls for a child view
  viewStyles: {}, // store styles from views to be extracted
  viewDynamicStyleKeys: null,
  viewStaticStyleKeys: null,
  viewRootNodes: null, // track root JSX elements
  viewState: null, // track which state to wrap
  viewStyleNames: null, // prevent duplicate style names

  init: function init() {
    state.resetProgramState();
    state.resetViewState();
  },

  resetProgramState: function resetProgramState() {
    state.hasView = false;
    state.hasExports = false;
    state.meta = { file: null, views: {} };
  },

  resetViewState: function resetViewState(fullName, file, loc) {
    state.hasView = true;
    state.keyBase = {};
    state.viewRootNodes = [];
    state.viewState = {};
    state.viewStyleNames = {};
    state.viewDynamicStyleKeys = {};
    state.viewStaticStyleKeys = {};
    state.viewHasChildWithClass = false;
  }
};

exports['default'] = state;
module.exports = exports['default'];